Index: XIOS/trunk/src/generate_interface_impl.hpp
===================================================================
--- XIOS/trunk/src/generate_interface_impl.hpp	(revision 368)
+++ XIOS/trunk/src/generate_interface_impl.hpp	(revision 369)
@@ -6,5 +6,6 @@
 #include "type_util.hpp"
 #include "indent.hpp"
-#include "array.hpp"
+#include "enum.hpp"
+#include "array_new.hpp"
 
 namespace xios
@@ -83,8 +84,33 @@
   }
 
+  template<>
+  void CInterface::AttributeCInterface<CEnumBase>(ostream& oss, const string& className,const string& name)  
+  {
+    oss<<"void cxios_set_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, const char * "<<name<<", int "<<name<<"_size)"<<iendl ;
+    oss<<"{"<<iendl ;
+    oss<<"  std::string "<<name<<"_str;"<<iendl;
+    oss<<"  if(!cstr2string("<<name<<", "<<name<<"_size, "<<name<<"_str)) return;"<<iendl ;
+    oss<<"   CTimer::get(\"XIOS\").resume();"<<iendl ;
+    oss<<"  "<<className<<"_hdl->"<<name<<".fromString("<<name<<"_str);"<<iendl ;
+    oss<<"  "<<className<<"_hdl->sendAttributToServer("<<className<<"_hdl->"<<name<<");"<<iendl ;
+    oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;
+    oss<<"}"<<iendl ;
+    
+    oss<<iendl ;
+    
+    oss<<"void cxios_get_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, char * "<<name<<", int "<<name<<"_size)"<<iendl ;
+    oss<<"{"<<iendl ;
+    oss<<"   CTimer::get(\"XIOS\").resume();"<<iendl ;
+    oss<<"  if(!string_copy("<<className<<"_hdl->"<<name<<".getStringValue(),"<<name<<" , "<<name<<"_size))"<<iendl ;
+    oss<<"    ERROR(\"void cxios_get_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, char * "<<name<<", int "
+       <<name<<"_size)\", <<\"Input string is to short\");"<<iendl ;
+    oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;
+    oss<<"}"<<iendl ;
+  
+  }
 //     if (!array_copy(domain_hdl->mask.getValue(), mask, extent1, extent2))
 //        ERROR("cxios_get_domain_mask(XDomainPtr domain_hdl, bool * mask, int extent1, int extent2)",<<"Output array size is not conform to array size attribut") ;
 
-
+/*
 #define macro(T) \
   template <>\
@@ -160,4 +186,5 @@
 macro(double)
 macro(int)
+*/
 
 #undef macro  
@@ -206,5 +233,6 @@
      
    }
-    
+
+/*
 #define macro(T)\
    template <>\
@@ -280,7 +308,7 @@
   macro(double)
   macro(int)
-  
+
   #undef macro
-  
+*/  
    template <class T>
    void CInterface::AttributeFortranInterfaceDeclaration(ostream& oss,const string& className,const string& name)
@@ -309,4 +337,5 @@
    }
 
+/*
 #define macro(T)\
    template <> \
@@ -356,5 +385,5 @@
 
 #undef macro
-
+*/
    
    template <class T>
@@ -404,5 +433,5 @@
    }
 
-
+/*
 #define macro(T) \
    template <>  \
@@ -459,5 +488,7 @@
 
 #undef macro
-
+*/
+
+/*
 #define macro(T) \
    template <>  \
@@ -514,4 +545,358 @@
 
 #undef macro
+*/
+
+// declaration for CArray
+
+
+
+
+#define macro(T) \
+  template <>\
+  void CInterface::AttributeCInterface<CArray<T,1> >(ostream& oss, const string& className,const string& name)\
+  {\
+    string typeName=getStrType<T>() ;\
+\
+    oss<<"void cxios_set_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, "<< typeName<<"* "<<name<<", int extent1)"<<iendl ;\
+    oss<<"{"<<iendl ;\
+    oss<<"  CTimer::get(\"XIOS\").resume();"<<iendl ; \
+    oss<<"  CArray<"<<typeName<<",1> tmp("<<name<<",shape(extent1),neverDeleteData) ;"<<iendl ;\
+    oss<<"  "<<className<<"_hdl->"<<name<<".reference(tmp.copy());"<<iendl ;\
+    oss<<"  "<<className<<"_hdl->sendAttributToServer("<<className<<"_hdl->"<<name<<");"<<iendl ;\
+    oss<<"}"<<iendl ;\
+    oss<<iendl; \
+    oss<<"void cxios_get_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, "<< typeName<<"* "<<name<<", int extent1)"<<iendl ;\
+    oss<<"{"<<iendl; \
+    oss<<"  CArray<"<<typeName<<",1> tmp("<<name<<",shape(extent1),neverDeleteData) ;"<<iendl ;\
+    oss<<"  tmp="<<className<<"_hdl->"<<name<<" ;"<<iendl ;\
+    oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;\
+    oss<<"}"<<iendl ;\
+  }\
+\
+  template <> \
+  void CInterface::AttributeCInterface<CArray<T,2> >(ostream& oss, const string& className,const string& name)\
+  {\
+    string typeName=getStrType<T>() ;\
+\
+    oss<<"void cxios_set_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, "<< typeName<<"* "<<name<<", int extent1, int extent2)"<<iendl ;\
+    oss<<"{"<<iendl ;\
+    oss<<"  CTimer::get(\"XIOS\").resume();"<<iendl ; \
+    oss<<"  CArray<"<<typeName<<",2> tmp("<<name<<",shape(extent1,extent2),neverDeleteData) ;"<<iendl ;\
+    oss<<"  "<<className<<"_hdl->"<<name<<".reference(tmp.copy());"<<iendl ;\
+    oss<<"  "<<className<<"_hdl->sendAttributToServer("<<className<<"_hdl->"<<name<<");"<<iendl ;\
+    oss<<"}"<<iendl ;\
+    oss<<iendl; \
+    oss<<"void cxios_get_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, "<< typeName<<"* "<<name<<", int extent1, int extent2)"<<iendl ;\
+    oss<<"{"<<iendl; \
+    oss<<"  CArray<"<<typeName<<",2> tmp("<<name<<",shape(extent1,extent2),neverDeleteData) ;"<<iendl ;\
+    oss<<"  tmp="<<className<<"_hdl->"<<name<<" ;"<<iendl ;\
+    oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;\
+    oss<<"}"<<iendl ;\
+  }\
+\
+  template <>\
+  void CInterface::AttributeCInterface<CArray<T,3> >(ostream& oss, const string& className,const string& name)\
+  {\
+    string typeName=getStrType<T>() ;\
+\
+    oss<<"void cxios_set_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, "<< typeName<<"* "<<name<<", int extent1, int extent2, int extent3)"<<iendl ;\
+    oss<<"{"<<iendl ;\
+    oss<<"  CTimer::get(\"XIOS\").resume();"<<iendl ; \
+    oss<<"  CArray<"<<typeName<<",2> tmp("<<name<<",shape(extent1,extent2,extent3),neverDeleteData) ;"<<iendl ;\
+    oss<<"  "<<className<<"_hdl->"<<name<<".reference(tmp.copy());"<<iendl ;\
+    oss<<"  "<<className<<"_hdl->sendAttributToServer("<<className<<"_hdl->"<<name<<");"<<iendl ;\
+    oss<<"}"<<iendl ;\
+    oss<<iendl; \
+    oss<<"void cxios_get_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl, "<< typeName<<"* "<<name<<", int extent1, int extent2, int extent3)"<<iendl ;\
+    oss<<"{"<<iendl; \
+    oss<<"  CArray<"<<typeName<<",2> tmp("<<name<<",shape(extent1,extent2,extent3),neverDeleteData) ;"<<iendl ;\
+    oss<<"  tmp="<<className<<"_hdl->"<<name<<" ;"<<iendl ;\
+    oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;\
+    oss<<"}"<<iendl ;\
+  }
+
+macro(bool)
+macro(double)
+macro(int)
+
+#undef macro  
+
+// /////////////////////////////////////////////////
+// //          Fortran 2003 Interface             //
+// /////////////////////////////////////////////////
+
+
+    
+#define macro(T)\
+   template <>\
+   void CInterface::AttributeFortran2003Interface<CArray<T,1> >(ostream& oss,const string& className,const string& name) \
+   { \
+     string fortranType=getStrFortranType<T>() ; \
+     string fortranKindC=getStrFortranKindC<T>() ; \
+      \
+     oss<<"SUBROUTINE cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<", extent1) BIND(C)"<<iendl ; \
+     oss<<"  USE ISO_C_BINDING"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE       :: "<<className<<"_hdl"<<iendl ; \
+     oss<<"  "<<fortranType<<" "<<fortranKindC<<"     , DIMENSION(*) :: "<<name<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
+     oss<<"END SUBROUTINE cxios_set_"<<className<<"_"<<name<<iendl ; \
+     oss<<iendl; \
+     oss<<"SUBROUTINE cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<", extent1) BIND(C)"<<iendl ; \
+     oss<<"  USE ISO_C_BINDING"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE       :: "<<className<<"_hdl"<<iendl ; \
+     oss<<"  "<<fortranType<<" "<<fortranKindC<<"     , DIMENSION(*) :: "<<name<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
+     oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ; \
+   } \
+ \
+   template <> \
+   void CInterface::AttributeFortran2003Interface<CArray<T,2> >(ostream& oss,const string& className,const string& name) \
+   { \
+     string fortranType=getStrFortranType<T>() ; \
+     string fortranKindC=getStrFortranKindC<T>() ; \
+      \
+     oss<<"SUBROUTINE cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<", extent1, extent2) BIND(C)"<<iendl ; \
+     oss<<"  USE ISO_C_BINDING"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE       :: "<<className<<"_hdl"<<iendl ; \
+     oss<<"  "<<fortranType<<" "<<fortranKindC<<"     , DIMENSION(*) :: "<<name<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent2"<<iendl ; \
+     oss<<"END SUBROUTINE cxios_set_"<<className<<"_"<<name<<iendl ; \
+     oss<<iendl ; \
+     oss<<"SUBROUTINE cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<", extent1, extent2) BIND(C)"<<iendl ; \
+     oss<<"  USE ISO_C_BINDING"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE       :: "<<className<<"_hdl"<<iendl ; \
+     oss<<"  "<<fortranType<<" "<<fortranKindC<<"     , DIMENSION(*) :: "<<name<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent2"<<iendl ; \
+     oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ; \
+   } \
+     \
+   template <> \
+   void CInterface::AttributeFortran2003Interface<CArray<T,3> >(ostream& oss,const string& className,const string& name) \
+   { \
+     string fortranType=getStrFortranType<T>() ; \
+     string fortranKindC=getStrFortranKindC<T>() ; \
+      \
+     oss<<"SUBROUTINE cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<", extent1, extent2, extent3) BIND(C)"<<iendl ; \
+     oss<<"  USE ISO_C_BINDING"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE       :: "<<className<<"_hdl"<<iendl ; \
+     oss<<"  "<<fortranType<<" "<<fortranKindC<<"     , DIMENSION(*) :: "<<name<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent2"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent3"<<iendl ; \
+     oss<<"END SUBROUTINE cxios_set_"<<className<<"_"<<name<<iendl ; \
+     oss<<iendl ;\
+     oss<<"SUBROUTINE cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<", extent1, extent2, extent3) BIND(C)"<<iendl ; \
+     oss<<"  USE ISO_C_BINDING"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE       :: "<<className<<"_hdl"<<iendl ; \
+     oss<<"  "<<fortranType<<" "<<fortranKindC<<"     , DIMENSION(*) :: "<<name<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent2"<<iendl ; \
+     oss<<"  INTEGER (kind = C_INT), VALUE  :: extent3"<<iendl ; \
+     oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ; \
+   }
+  
+  macro(bool)
+  macro(double)
+  macro(int)
+  
+  #undef macro
+  
+
+#define macro(T)\
+   template <> \
+   void CInterface::AttributeFortranInterfaceDeclaration<CArray<T,1> >(ostream& oss,const string& className,const string& name) \
+   { \
+     oss<<getStrFortranType<T>()<<" "<<getStrFortranKind<T>() <<" , OPTIONAL, INTENT(IN) :: "<<name<<"(:)"<<iendl ; \
+     if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>() <<" , ALLOCATABLE :: "<<name<<"_tmp(:)"<<iendl ; \
+   } \
+   template <> \
+   void CInterface::AttributeFortranInterfaceGetDeclaration<CArray<T,1> >(ostream& oss,const string& className,const string& name) \
+   { \
+     oss<<getStrFortranType<T>()<<" "<<getStrFortranKind<T>() <<" , OPTIONAL, INTENT(OUT) :: "<<name<<"(:)"<<iendl ; \
+     if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>() <<" , ALLOCATABLE :: "<<name<<"_tmp(:)"<<iendl ; \
+   } \
+ \
+   template <> \
+   void CInterface::AttributeFortranInterfaceDeclaration<CArray<T,2> >(ostream& oss,const string& className,const string& name) \
+   { \
+     oss<<getStrFortranType<T>()<<" "<<getStrFortranKind<T>() <<" , OPTIONAL, INTENT(IN) :: "<<name<<"(:,:)"<<iendl ; \
+     if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>() <<" , ALLOCATABLE :: "<<name<<"_tmp(:,:)"<<iendl ; \
+   } \
+ \
+   template <> \
+   void CInterface::AttributeFortranInterfaceGetDeclaration<CArray<T,2> >(ostream& oss,const string& className,const string& name) \
+   { \
+     oss<<getStrFortranType<T>()<<" "<<getStrFortranKind<T>() <<" , OPTIONAL, INTENT(OUT) :: "<<name<<"(:,:)"<<iendl ; \
+     if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>() <<" , ALLOCATABLE :: "<<name<<"_tmp(:,:)"<<iendl ; \
+   } \
+ \
+   template <> \
+   void CInterface::AttributeFortranInterfaceDeclaration<CArray<T,3> >(ostream& oss,const string& className,const string& name) \
+   { \
+     oss<<getStrFortranType<T>()<<" "<<getStrFortranKind<T>() <<" , OPTIONAL, INTENT(IN) :: "<<name<<"(:,:,:)"<<iendl ; \
+     if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>() <<" , ALLOCATABLE :: "<<name<<"_tmp(:,:,:)"<<iendl ; \
+   }\
+ \
+   template <> \
+   void CInterface::AttributeFortranInterfaceGetDeclaration<CArray<T,3> >(ostream& oss,const string& className,const string& name) \
+   { \
+     oss<<getStrFortranType<T>()<<" "<<getStrFortranKind<T>() <<" , OPTIONAL, INTENT(OUT) :: "<<name<<"(:,:,:)"<<iendl ; \
+     if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>() <<" , ALLOCATABLE :: "<<name<<"_tmp(:,:,:)"<<iendl ; \
+   }     
+   
+  macro(bool)
+  macro(double)
+  macro(int)
+
+#undef macro
+
+   
+
+#define macro(T) \
+   template <>  \
+   void CInterface::AttributeFortranInterfaceBody< CArray<T,1> >(ostream& oss,const string& className,const string& name) \
+   {  \
+     string name_tmp=name+"__tmp" ; \
+      \
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ; \
+     if (!matchingTypeCFortran<T>())  \
+     { \
+       oss<<"  ALLOCATE("<<name_tmp<<"(size("<<name<<"_,1)))"<<iendl ; \
+       oss<<"  "<<name_tmp<<"="<<name<<"_"<<iendl ; \
+       oss<<"  CALL cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name_tmp<<",size("<<name<<"_,1))"<<iendl ; \
+     } \
+     else oss<<"  CALL cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name<<"_,size("<<name<<"_,1))"<<iendl ; \
+     oss<<"ENDIF"<<iendl ; \
+   } \
+ \
+   template <>  \
+   void CInterface::AttributeFortranInterfaceBody< CArray<T,2> >(ostream& oss,const string& className,const string& name) \
+   {  \
+     string name_tmp=name+"__tmp" ; \
+      \
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ; \
+     if (!matchingTypeCFortran<T>())  \
+     { \
+       oss<<"  ALLOCATE("<<name_tmp<<"(size("<<name<<"_,1),size("<<name<<"_,2)))"<<iendl ; \
+       oss<<"  "<<name_tmp<<"="<<name<<"_"<<iendl ; \
+       oss<<"  CALL cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name_tmp<<",size("<<name<<"_,1),size("<<name<<"_,2))"<<iendl ; \
+     } \
+     else oss<<"  CALL cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name<<"_,size("<<name<<"_,1),size("<<name<<"_,2))"<<iendl ; \
+     oss<<"ENDIF"<<iendl ; \
+   } \
+    \
+   template <>  \
+   void CInterface::AttributeFortranInterfaceBody< CArray<T,3> >(ostream& oss,const string& className,const string& name) \
+   {  \
+     string name_tmp=name+"__tmp" ; \
+      \
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ; \
+     if (!matchingTypeCFortran<T>())  \
+     { \
+       oss<<"  ALLOCATE("<<name_tmp<<"(size("<<name<<"_,1),size("<<name<<"_,2),size("<<name<<"_,3)))"<<iendl ; \
+       oss<<"  "<<name_tmp<<"="<<name<<"_"<<iendl ; \
+       oss<<"  CALL cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name_tmp<<",size("<<name<<"_,1),size("<<name<<"_,2),size("<<name<<"_,3))"<<iendl ; \
+     } \
+     else oss<<"  CALL cxios_set_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name<<"_,size("<<name<<"_,1),size("<<name<<"_,2),size("<<name<<"_,3))"<<iendl ; \
+     oss<<"ENDIF"<<iendl ; \
+   }
+  
+  macro(bool)
+  macro(double)
+  macro(int)
+
+#undef macro
+
+#define macro(T) \
+   template <>  \
+   void CInterface::AttributeFortranInterfaceGetBody< CArray<T,1> >(ostream& oss,const string& className,const string& name) \
+   {  \
+     string name_tmp=name+"__tmp" ; \
+      \
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ; \
+     if (!matchingTypeCFortran<T>())  \
+     { \
+       oss<<"  ALLOCATE("<<name_tmp<<"(size("<<name<<"_,1)))"<<iendl ; \
+       oss<<"  CALL cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name_tmp<<",size("<<name<<"_,1))"<<iendl ; \
+       oss<<"  "<<name<<"_="<<name_tmp<<"_"<<iendl ; \
+     } \
+     else oss<<"  CALL cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name<<"_,size("<<name<<"_,1))"<<iendl ; \
+     oss<<"ENDIF"<<iendl ; \
+   } \
+ \
+   template <>  \
+   void CInterface::AttributeFortranInterfaceGetBody< CArray<T,2> >(ostream& oss,const string& className,const string& name) \
+   {  \
+     string name_tmp=name+"__tmp" ; \
+      \
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ; \
+     if (!matchingTypeCFortran<T>())  \
+     { \
+       oss<<"  ALLOCATE("<<name_tmp<<"(size("<<name<<"_,1),size("<<name<<"_,2)))"<<iendl ; \
+       oss<<"  CALL cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name_tmp<<",size("<<name<<"_,1),size("<<name<<"_,2))"<<iendl ; \
+       oss<<"  "<<name<<"_="<<name_tmp<<iendl ; \
+     } \
+     else oss<<"  CALL cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name<<"_,size("<<name<<"_,1),size("<<name<<"_,2))"<<iendl ; \
+     oss<<"ENDIF"<<iendl ; \
+   } \
+    \
+   template <>  \
+   void CInterface::AttributeFortranInterfaceGetBody< CArray<T,3> >(ostream& oss,const string& className,const string& name) \
+   {  \
+     string name_tmp=name+"__tmp" ; \
+      \
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ; \
+     if (!matchingTypeCFortran<T>())  \
+     { \
+       oss<<"  ALLOCATE("<<name_tmp<<"(size("<<name<<"_,1),size("<<name<<"_,2),size("<<name<<"_,3)))"<<iendl ; \
+       oss<<"  CALL cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name_tmp<<",size("<<name<<"_,1),size("<<name<<"_,2),size("<<name<<"_,3))"<<iendl ; \
+       oss<<"  "<<name<<"_="<<name_tmp<<iendl ; \
+      } \
+     else oss<<"  CALL cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr, "<<name<<"_,size("<<name<<"_,1),size("<<name<<"_,2),size("<<name<<"_,3))"<<iendl ; \
+     oss<<"ENDIF"<<iendl ; \
+   }
+     
+  macro(bool)
+  macro(double)
+  macro(int)
+
+#undef macro
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
 }
 
Index: XIOS/trunk/src/group_template.hpp
===================================================================
--- XIOS/trunk/src/group_template.hpp	(revision 368)
+++ XIOS/trunk/src/group_template.hpp	(revision 369)
@@ -45,6 +45,6 @@
          virtual void fromString(const StdString & str);
          
-         virtual void toBinary  (StdOStream & os) const;
-         virtual void fromBinary(StdIStream & is);
+//         virtual void toBinary  (StdOStream & os) const;
+//         virtual void fromBinary(StdIStream & is);
 
          virtual void parse(xml::CXMLNode & node);
Index: XIOS/trunk/src/group_template_impl.hpp
===================================================================
--- XIOS/trunk/src/group_template_impl.hpp	(revision 368)
+++ XIOS/trunk/src/group_template_impl.hpp	(revision 369)
@@ -38,5 +38,5 @@
    
    ///--------------------------------------------------------------
-   
+/*
    template <class U, class V, class W>
       void CGroupTemplate<U, V, W>::toBinary(StdOStream & os) const
@@ -161,5 +161,5 @@
       }
    }
-
+*/
    //--------------------------------------------------------------
 
Index: XIOS/trunk/src/input/inetcdf4.cpp
===================================================================
--- XIOS/trunk/src/input/inetcdf4.cpp	(revision 368)
+++ XIOS/trunk/src/input/inetcdf4.cpp	(revision 369)
@@ -710,5 +710,5 @@
 
       template <>
-         void CINetCDF4::getData(ARRAY(int, 1) data, const StdString & var,
+         void CINetCDF4::getData(CArray<int, 1>& data, const StdString & var,
                                  const CVarPath  * const path, StdSize record)
       {
@@ -719,10 +719,10 @@
          StdSize array_size = 1;
          this->getDataInfo(var, path, record, start, count, array_size);
-         data->resize(boost::extents[array_size]);
-         CheckError(nc_get_vara_int (grpid, varid, &(start[0]), &(count[0]), data->data()));
+         data.resize(array_size);
+         CheckError(nc_get_vara_int (grpid, varid, &(start[0]), &(count[0]), data.dataFirst()));
       }
 
       template <>
-         void CINetCDF4::getData(ARRAY(double, 1) data, const StdString & var,
+         void CINetCDF4::getData(CArray<double, 1>& data, const StdString & var,
                                  const CVarPath  * const path, StdSize record)
       {
@@ -732,10 +732,10 @@
          StdSize array_size = 1;
          this->getDataInfo(var, path, record, start, count, array_size);
-         data->resize(boost::extents[array_size]);
-         CheckError(nc_get_vara_double (grpid, varid, &(start[0]), &(count[0]), data->data()));
+         data.resize(array_size);
+         CheckError(nc_get_vara_double (grpid, varid, &(start[0]), &(count[0]), data.dataFirst()));
       }
 
       template <>
-         void CINetCDF4::getData(ARRAY(float, 1) data, const StdString & var,
+         void CINetCDF4::getData(CArray<float, 1>& data, const StdString & var,
                                  const CVarPath  * const path, StdSize record)
       {
@@ -745,6 +745,6 @@
          StdSize array_size = 1;
          this->getDataInfo(var, path, record, start, count, array_size);
-         data->resize(boost::extents[array_size]);
-         CheckError(nc_get_vara_float (grpid, varid, &(start[0]), &(count[0]), data->data()));
+         data.resize(array_size);
+         CheckError(nc_get_vara_float (grpid, varid, &(start[0]), &(count[0]), data.dataFirst()));
       }
 
Index: XIOS/trunk/src/input/inetcdf4.hpp
===================================================================
--- XIOS/trunk/src/input/inetcdf4.hpp	(revision 368)
+++ XIOS/trunk/src/input/inetcdf4.hpp	(revision 369)
@@ -5,5 +5,5 @@
 #include "xmlioserver_spl.hpp"
 #include "exception.hpp"
-#include "array.hpp"
+#include "array_new.hpp"
 
 #include <mpi.h>
@@ -92,5 +92,5 @@
 
             template <class T>
-               void getData(ARRAY(T, 1) data,
+               void getData(CArray<T, 1>& data,
                             const StdString & var,
                             const CVarPath  * const path = NULL,
@@ -220,13 +220,13 @@
       //---------------------------------------------------------------
       template <>
-         void CINetCDF4::getData(ARRAY(int, 1) data, const StdString & var,
+         void CINetCDF4::getData(CArray<int, 1>& data, const StdString & var,
                                  const CVarPath  * const path, StdSize record);
 
       template <>
-         void CINetCDF4::getData(ARRAY(double, 1) data, const StdString & var,
+         void CINetCDF4::getData(CArray<double, 1>& data, const StdString & var,
                                  const CVarPath  * const path, StdSize record);
 
       template <>
-         void CINetCDF4::getData(ARRAY(float, 1) data, const StdString & var,
+         void CINetCDF4::getData(CArray<float, 1>& data, const StdString & var,
                                  const CVarPath  * const path, StdSize record);
       ///--------------------------------------------------------------
Index: XIOS/trunk/src/interface/c/icdata.cpp
===================================================================
--- XIOS/trunk/src/interface/c/icdata.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c/icdata.cpp	(revision 369)
@@ -23,4 +23,5 @@
 #include <mpi.h>
 #include "timer.hpp"
+#include "array_new.hpp"
 
 extern "C"
@@ -111,12 +112,9 @@
       CTimer::get("XIOS send field").resume() ;
       CContext* context = CContext::getCurrent() ;
-//      boost::const_multi_array_ref<double, 1> array_(data_k8,
-//          boost::extents [data_Xsize],
-//          boost::fortran_storage_order());
-      ARRAY(double, 1) data(new CArray<double, 1>(boost::extents [data_Xsize]));
-      std::copy(data_k8, &(data_k8[data->num_elements()]), data->data());
-      
-//      dtreat->write_data(fieldid_str, data);
-      CField::get(fieldid_str)->setData(data) ;
+
+      CArray<double,(StdSize)1> data(data_k8,shape(data_Xsize),neverDeleteData) ;
+      CField::get(fieldid_str)->setData(data) ;
+      CField toto ;
+      toto.setData(data) ;
       CTimer::get("XIOS send field").suspend() ;
       CTimer::get("XIOS").suspend() ;
@@ -132,10 +130,5 @@
       CContext* context = CContext::getCurrent() ;
       
-//      boost::const_multi_array_ref<double, 2> array_(data_k8,
-//          boost::extents [data_Xsize][data_Ysize],
-//          boost::fortran_storage_order());
-      ARRAY(double, 2) data(new CArray<double, 2>(boost::extents [data_Xsize][data_Ysize]));
-      std::copy(data_k8, &(data_k8[data->num_elements()]), data->data());
-//      dtreat->write_data(fieldid_str, data);
+      CArray<double,2>data(data_k8,shape(data_Xsize,data_Ysize),neverDeleteData) ;
       CField::get(fieldid_str)->setData(data) ;
       CTimer::get("XIOS send field").suspend() ;
@@ -151,10 +144,6 @@
       CTimer::get("XIOS send field").resume() ;
       CContext* context = CContext::getCurrent() ;
-//      boost::const_multi_array_ref<double, 3> array_(data_k8,
-//          boost::extents [data_Xsize][data_Ysize][data_Zsize],
-//          boost::fortran_storage_order());
-      ARRAY(double, 3) data(new CArray<double, 3>(boost::extents [data_Xsize][data_Ysize][data_Zsize]));
-      std::copy(data_k8, &(data_k8[data->num_elements()]), data->data());
-//      dtreat->write_data(fieldid_str, data);
+
+      CArray<double,3>data(data_k8,shape(data_Xsize,data_Ysize,data_Zsize),neverDeleteData) ;
       CField::get(fieldid_str)->setData(data) ;
       CTimer::get("XIOS send field").suspend() ;
@@ -170,13 +159,7 @@
       CTimer::get("XIOS send field").resume() ;
       CContext* context = CContext::getCurrent() ;
-//      boost::const_multi_array_ref<float, 1> array_(data_k4,
-//          boost::extents [data_Xsize],
-//          boost::fortran_storage_order());
-//      ARRAY(float, 1) data(new CArray<float, 1>(boost::extents [data_Xsize]));
-//      std::copy(data_k4, &(data_k4[data->num_elements()]), data->data());
-//      dtreat->write_data(fieldid_str, data);
-      ARRAY(double, 1) data(new CArray<double, 1>(boost::extents [data_Xsize]));
-      double* ptr_data=data->data() ; 
-      for(int i=0;i<data->num_elements();i++) ptr_data[i]=data_k4[i];
+      CArray<float,1> data_tmp(data_k4,shape(data_Xsize),neverDeleteData) ;
+      CArray<double,1> data(data_Xsize) ;
+      data=data_tmp ;
       CField::get(fieldid_str)->setData(data) ;
       CTimer::get("XIOS send field").suspend() ;
@@ -192,13 +175,7 @@
       CTimer::get("XIOS send field").resume() ;
       CContext* context = CContext::getCurrent() ;
-//      boost::const_multi_array_ref<float, 2> array_(data_k4,
-//          boost::extents [data_Xsize][data_Ysize],
-//          boost::fortran_storage_order());
-//      ARRAY(float, 2) data(new CArray<float, 2>(boost::extents [data_Xsize][data_Ysize]));
-//      std::copy(data_k4, &(data_k4[data->num_elements()]), data->data());
-//      dtreat->write_data(fieldid_str, data);
-      ARRAY(double, 2) data(new CArray<double, 2>(boost::extents [data_Xsize][data_Ysize]));
-      double* ptr_data=data->data() ; 
-      for(int i=0;i<data->num_elements();i++) ptr_data[i]=data_k4[i];
+      CArray<float,2> data_tmp(data_k4,shape(data_Xsize,data_Ysize),neverDeleteData) ;
+      CArray<double,2> data(data_Xsize,data_Ysize) ;
+      data=data_tmp ;
       CField::get(fieldid_str)->setData(data) ;
       CTimer::get("XIOS send field").suspend() ;
@@ -215,14 +192,9 @@
       CTimer::get("XIOS send field").resume() ;
       CContext* context = CContext::getCurrent() ;
-     
-//      boost::const_multi_array_ref<float, 3> array_(data_k4,
-//          boost::extents [data_Xsize][data_Ysize][data_Zsize],
-//          boost::fortran_storage_order());
-//      ARRAY(float, 3) data(new CArray<float, 3>(boost::extents [data_Xsize][data_Ysize][data_Zsize]));
-//      std::copy(data_k4, &(data_k4[data->num_elements()]), data->data());
-//      dtreat->write_data(fieldid_str, data);
-      ARRAY(double, 3) data(new CArray<double, 3>(boost::extents [data_Xsize][data_Ysize][data_Zsize]));
-      double* ptr_data=data->data() ; 
-      for(int i=0;i<data->num_elements();i++) ptr_data[i]=data_k4[i];
+
+      CArray<float,3> data_tmp(data_k4,shape(data_Xsize,data_Ysize,data_Zsize),neverDeleteData) ;
+      CArray<double,3> data(data_Xsize,data_Ysize,data_Zsize) ;
+      data=data_tmp ;
+ 
       CField::get(fieldid_str)->setData(data) ;
       CTimer::get("XIOS send field").suspend() ;
Index: XIOS/trunk/src/interface/c/icutil.hpp
===================================================================
--- XIOS/trunk/src/interface/c/icutil.hpp	(revision 368)
+++ XIOS/trunk/src/interface/c/icutil.hpp	(revision 369)
@@ -40,4 +40,5 @@
   }
 }
+/*
   template<class T>
   inline  bool array_copy(ARRAY(T,1) array_in, T* array_out, size_t extent1)
@@ -63,5 +64,5 @@
     return true ;
   }        
-
+*/
 
 #endif // __ICUTIL_HPP__
